#ifndef VIDCAPCONFIGDIALOG_H
#define VIDCAPCONFIGDIALOG_H

#include "okdialog.h"

class QButtonGroup;
class QCheckBox;
class QComboBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;
class QTabWidget;
class QWidget;

class VidcapConfigDialog : public QavmOkDialog
{
    Q_OBJECT

public:
    VidcapConfigDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~VidcapConfigDialog();

    QTabWidget* tabWidget;
    QComboBox* _Colorspace;
    QComboBox* _Resolution;
    QLineEdit* _CapDevice;
    QLineEdit* _AudDevice;
    QComboBox* _VideoColorMode;
    QComboBox* _VideoChannel;
    QLineEdit* _FileName;
    QPushButton* _ChangeFile;
    QComboBox* _fps;
    QCheckBox* _HaveSegmented;
    QLineEdit* _SegmentSize;
    QComboBox* _listSamp;
    QCheckBox* _HaveAudio;
    QComboBox* _listFreq;
    QComboBox* _listChan;
    QLabel* _codecName;
    QPushButton* _ChangeCodec;
    QButtonGroup* ButtonGroup1;
    QCheckBox* _chkFileSize;
    QLineEdit* _timeLimit;
    QLineEdit* _sizeLimit;
    QCheckBox* _chkTime;

public slots:
    virtual void apply() = 0;
    virtual void change_codec() = 0;
    virtual void change_filename() = 0;
    virtual void toggle_audio(bool) = 0;
    virtual void toggle_limitsize(bool) = 0;
    virtual void toggle_limittime(bool) = 0;
    virtual void toggle_segmented(bool) = 0;
};

#endif // VIDCAPCONFIGDIALOG_H
